=== debian/changelog ===
vecgeom (1.2.5+dfsg-1build2) noble; urgency=high

  * No change rebuild against libxerces-c3.2t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:58:39 +0100

vecgeom (1.2.5+dfsg-1build1) noble; urgency=medium

  * Rebuild against new libembree4-4.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 17 Jan 2024 20:35:25 +0100

vecgeom (1.2.5+dfsg-1) unstable; urgency=medium

  * New upstream version 1.2.5+dfsg

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 26 Oct 2023 18:52:26 +0200
