=== debian/changelog ===
vecgeom (1.2.8+dfsg-2) unstable; urgency=medium

  * Remove embree depends which was forgotten in 1.2.8+dfsg-1

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 31 Jul 2024 14:25:02 +0200

vecgeom (1.2.8+dfsg-1) unstable; urgency=medium

  * New upstream version 1.2.8+dfsg
  * Disable embree support, broken upstream (Closes: #1063044)

 -- Stephan Lachnit <stephanlachnit@debian.org>  Tue, 30 Jul 2024 18:38:33 +0200
