=== debian/control ===
--- 
+++ 
@@ -1,17 +1,15 @@
 Source: vecgeom
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Stephan Lachnit <stephanlachnit@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
- libembree-dev [any-amd64],
  libxerces-c-dev,
  vc-dev [any-amd64 any-arm any-arm64 any-i386],
  veccore-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/science-team/vecgeom
 Vcs-Git: https://salsa.debian.org/science-team/vecgeom.git
@@ -28,7 +26,6 @@
  veccore-dev,
  vc-dev [any-amd64 any-arm any-arm64 any-i386],
  libxerces-c-dev,
- libembree-dev [any-amd64],
 Description: geometry library for particle-detector simulation - development files
  VecGeom is a vectorized geometry modeller library with hit-detection features
  as needed by particle detector simulation at the LHC and beyond.
@@ -44,7 +41,6 @@
  libvecgeom1.2 (= ${binary:Version}),
  veccore-dev,
  vc-dev [any-amd64 any-arm any-arm64 any-i386],
- libembree-dev [any-amd64],
 Suggests:
  vecgeom-dev (= ${binary:Version}),
 Breaks: vecgeom-dev (<< 1.1.19+dfsg-1)
