=== debian/watch ===
version=4
opts="searchmode=plain,dversionmangle=s%\+dfsg\d*$%%,repacksuffix=+dfsg" \
    https://gitlab.cern.ch/api/v4/projects/VecGeom%2FVecGeom/releases \
    https://gitlab.cern.ch/VecGeom/VecGeom/-/archive/[^/]+?/VecGeom@ANY_VERSION@@ARCHIVE_EXT@
